local NAME, ADDON = ...

ADDON.cache = {}
ADDON.cache.__index = ADDON.cache

local cache = ADDON.cache
cache.items = {}
cache.bagContainers = {}

function cache:GetItem(bag, slot)
    self.items[bag] = self.items[bag] or {}
    self.items[bag][slot] = self.items[bag][slot] or ADDON.item(bag, slot)
    return self.items[bag][slot]
end

function cache:GetBagContainer()
    if not self.bagContainer then
        self.bagContainer = ADDON.categoryContainer('DJBagsBagCategoryContainer', UIParent)
        self.bagContainer:SetPoint('BOTTOMRIGHT', -200, 200)
        self.bagContainer:SetUserPlaced(true)
        self.bagContainer:Hide()
        self.bagContainer.moneyBar = ADDON.moneyBar(self.bagContainer)
        self.bagContainer.moneyBar:SetPoint('TOPRIGHT', self.bagContainer, 'BOTTOMRIGHT', 0, -2)
        self.bagContainer.moneyBar:Show()
    end
    return self.bagContainer
end

function cache:GetBagItemContainer(name)
    self.bagContainers[name] = self.bagContainers[name] or ADDON.itemContainer(name, name ~= ADDON.utils.EMPTY_BAG_NAME)
    self:GetBagContainer():AddContainer(self.bagContainers[name])
    return self.bagContainers[name]
end

function cache:ShouldUpdate()
    return self:GetBagContainer():IsVisible()
end